package com.urbancode.air.plugin.udeploy.system

import com.urbancode.air.AirPluginTool
import com.urbancode.ud.client.UDRestClient
import org.codehaus.jettison.json.JSONArray;
import org.codehaus.jettison.json.JSONException;
import org.codehaus.jettison.json.JSONObject;

public class SystemHelper {
    def apTool
    def props = []
    def udUser
    def udPass
    def weburl
    UDRestClient client
    
    public SystemHelper(def apToolIn) {
        apTool = apToolIn
        props = apTool.getStepProperties()
        udUser = apTool.getAuthTokenUsername()
        udPass = apTool.getAuthToken()
        weburl = System.getenv("AH_WEB_URL")
        client = new UDRestClient(new URI(weburl), udUser, udPass)
        
        com.urbancode.air.XTrustProvider.install()
    }
    
    def setSystemProperty() {
        def propName = props['name']
        def propValue = props['value']
        def isSecure = Boolean.valueOf(props['isSecure'])
        
        if (!propName) {
            throw new IllegalArgumentException("no property name was specified")
        }
        if (!propValue) {
            propValue = ""
        }
        client.setSystemProperty(propName, propValue, isSecure)
    }
    
    def getSystemConfiguration() {
        def values = client.getSystemConfiguration()
        
        values.keys().each() { key ->
            apTool.setOutputProperty(key, values.optString(key))
        }
        
        apTool.setOutputProperties()
    }
    
    def setSystemConfiguration() {
        def propertiesString = props['properties']
        def properties = new Properties()
        properties.load(new ByteArrayInputStream(propertiesString.getBytes()))
        
        def propertyMap = new HashMap<String, String>()
        for (def key : properties.keySet()) {
            def value = properties.get(key)
            propertyMap.put(key, value)
            
            println "Setting "+key+" to "+value
        }
        
        client.setSystemConfiguration(propertyMap)
    }
}